# ===================================================================
# dynamic optimization formulation of the hicks-ray reactor
# create results file for matlab
# victor m zavala  march 2006
# ===================================================================

printf "clc\n" >perturbasjon2.m;
printf "clear all" >perturbasjon2.m;
printf "\n" >perturbasjon2.m;

# display variables and parameters

printf "x0 =[" >perturbasjon2.m;
printf {i in 1..NT}:
"%5.5f ",x[i]>>perturbasjon2.m;
printf "]';\n" >>perturbasjon2.m;

printf "x =[" >perturbasjon2.m;
printf {i in 1..NT}:
"%5.5f ",x.sens_sol_state_1[i]>>perturbasjon2.m;
printf "]';\n" >>perturbasjon2.m;

printf "M =[" >perturbasjon2.m;
printf {i in NT+1..NT*2}:
"%5.5f ",x[i]>>perturbasjon2.m;
printf "]';\n" >>perturbasjon2.m;

printf "M_1 =[" >perturbasjon2.m;
printf {i in NT+1..NT*2}:
"%5.5f ",x.sens_sol_state_1[i]>>perturbasjon2.m;
printf "]';\n" >>perturbasjon2.m;



printf "T0 =[" >perturbasjon2.m;
printf {i in 1..NT}:
"%5.5f ",T0[i]>>perturbasjon2.m;
printf "]';\n" >>perturbasjon2.m;

printf "T =[" >perturbasjon2.m;
printf {i in 1..NT}:
"%5.5f ",T[i]>>perturbasjon2.m;
printf "]';\n" >>perturbasjon2.m;

printf "stage =[" >perturbasjon2.m;
printf {i in 1..NT}:
"%5.5f ",stage[i]>>perturbasjon2.m;
printf "]';\n" >>perturbasjon2.m;

printf ";\n" >>perturbasjon2.m;

printf "Tb_ben = %5.5f ",Tb_ben>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
printf "Tb_tol= %5.5f ",Tb_tol>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;

printf ";\n" >>perturbasjon2.m;
 
printf "nominal_F = %5.2f ",F>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
printf "perturbed_F = %5.2f ",F.sens_sol_state_1>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
printf "nominal_pV = %5.5f ",pV>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
printf "perturbed_pV = %5.5f ",pV.sens_sol_state_1>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
printf "nominal_zF = %5.2f ",zF>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
printf "perturbed_qF = %5.2f ",zF.sens_sol_state_1>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
printf "nominal_qF = %5.2f ",qF>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
printf "perturbed_qF = %5.2f ",qF.sens_sol_state_1>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;

printf "\n">>perturbasjon2.m;

printf "LT = %5.5f ",LT>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
#printf "LT2 = %5.5f ",LT.sens_sol_state_1>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;

printf "VB = %5.5f ",VB>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
#printf "VB2= %5.5f ",VB.sens_sol_state_1>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;

printf "LT_F = %5.5f ",LT/F>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
#printf "LT_F_1 = %5.5f ",LT.sens_sol_state_1/F.sens_sol_state_1>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;

printf "\n">>perturbasjon2.m;

printf "VB_F = %5.5f ",VB/F>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
#printf "VB_F_1 = %5.5f ",VB.sens_sol_state_1/F.sens_sol_state_1>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;

printf "\n">>perturbasjon2.m;

printf "LT_D = %5.5f ",LT/D>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
#printf "LT_D_1 = %5.5f ",LT.sens_sol_state_1/D.sens_sol_state_1>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;

printf "\n">>perturbasjon2.m;

printf "VB_B = %5.5f ",VB/B>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
#printf "VB_B_1 = %5.5f ",VB.sens_sol_state_1/B.sens_sol_state_1>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;

printf "\n">>perturbasjon2.m;

printf "B = %5.5f ",B>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
printf "B_1 = %5.5f ",B.sens_sol_state_1>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;

printf "\n">>perturbasjon2.m;

printf "D = %5.5f ", D>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
printf "D_1 = %5.5f ",D.sens_sol_state_1>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;

printf "\n">>perturbasjon2.m;

printf "xB = %5.5f ", 1-x[1]>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
printf "xB_1 = %5.5f ",1-x.sens_sol_state_1[1]>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;

printf "\n">>perturbasjon2.m;

printf "xD = %5.5f ", x[NT]>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
printf "xD_1 = %5.5f ",x.sens_sol_state_1[NT]>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;

printf "\n">>perturbasjon2.m;

printf "cost = %5.5f ", cost>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
printf "cost_1 = %5.5f ",cost.sens_sol_state_1>>perturbasjon2.m; printf ";\n">>perturbasjon2.m;

# plot the results

# printf "subplot(2,1,1)\n" >>perturbasjon2.m;
# printf "plot(stage,x)\n" >>perturbasjon2.m;
# printf "xlabel ('stage number')">>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
# printf "ylabel ('composition')">>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
# printf "subplot(2,1,2)\n" >>perturbasjon2.m;
# printf "plot(stage,T)\n" >>perturbasjon2.m;
# printf "axis([1 41])">>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
# printf "subplot(3,1,3)\n" >>perturbasjon2.m;
# printf "plot(time,u)\n" >>perturbasjon2.m;
# printf "xlabel ('time')">>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
# printf "ylabel ('cooling w flowrate')">>perturbasjon2.m; printf ";\n">>perturbasjon2.m;
  

close perturbasjon2.m;
printf "output written to matlab m-file: perturbasjon2.m ...\n";
#-- end of the perturbasjon2shicks.inc file -

