# ===================================================================
# dynamic optimization formulation of the hicks-ray reactor
# create results file for matlab
# victor m zavala  march 2006
# ===================================================================

printf "clc\n" >pertubasjon1.m;
printf "clear all" >pertubasjon1.m;
printf "\n" >pertubasjon1.m;

# display variables and parameters

printf "pD_2 = %5.2f ",pD2>>case1b_xB.m; printf ";\n">>pertubasjon1.m;

printf "x0 =[" >pertubasjon1.m;
printf {i in 1..NT}:
"%5.5f ",x[i]>>pertubasjon1.m;
printf "]';\n" >>pertubasjon1.m;

printf "x =[" >pertubasjon1.m;
printf {i in 1..NT}:
"%5.5f ",x.sens_sol_state_1[i]>>pertubasjon1.m;
printf "]';\n" >>pertubasjon1.m;

printf "M =[" >pertubasjon1.m;
printf {i in NT+1..NT*2}:
"%5.5f ",x[i]>>pertubasjon1.m;
printf "]';\n" >>pertubasjon1.m;

printf "M_1 =[" >pertubasjon1.m;
printf {i in NT+1..NT*2}:
"%5.5f ",x.sens_sol_state_1[i]>>pertubasjon1.m;
printf "]';\n" >>pertubasjon1.m;


printf "T0 =[" >pertubasjon1.m;
printf {i in 1..NT}:
"%5.5f ",T0[i]>>pertubasjon1.m;
printf "]';\n" >>pertubasjon1.m;

printf "T =[" >pertubasjon1.m;
printf {i in 1..NT}:
"%5.5f ",T[i]>>pertubasjon1.m;
printf "]';\n" >>pertubasjon1.m;

printf "stage =[" >pertubasjon1.m;
printf {i in 1..NT}:
"%5.5f ",stage[i]>>pertubasjon1.m;
printf "]';\n" >>pertubasjon1.m;

printf ";\n" >>pertubasjon1.m;

printf "Tb_ben = %5.5f ",Tb_ben>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
printf "Tb_tol= %5.5f ",Tb_tol>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;

printf ";\n" >>pertubasjon1.m;
 
printf "nominal_F = %5.2f ",F>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
printf "perturbed_F = %5.2f ",F.sens_sol_state_1>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
printf "nominal_pV = %5.5f ",pV>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
printf "perturbed_pV = %5.5f ",pV.sens_sol_state_1>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
printf "nominal_zF = %5.2f ",zF>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
printf "perturbed_qF = %5.2f ",zF.sens_sol_state_1>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
printf "nominal_qF = %5.2f ",qF>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
printf "perturbed_qF = %5.2f ",qF.sens_sol_state_1>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;

printf "\n">>pertubasjon1.m;

printf "LT = %5.5f ",LT>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
#printf "LT2 = %5.5f ",LT.sens_sol_state_1>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;

printf "VB = %5.5f ",VB>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
#printf "VB2= %5.5f ",VB.sens_sol_state_1>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;

printf "LT_F = %5.5f ",LT/F>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
#printf "LT_F_1 = %5.5f ",LT.sens_sol_state_1/F.sens_sol_state_1>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;

printf "\n">>pertubasjon1.m;

printf "VB_F = %5.5f ",VB/F>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
#printf "VB_F_1 = %5.5f ",VB.sens_sol_state_1/F.sens_sol_state_1>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;

printf "\n">>pertubasjon1.m;

printf "LT_D = %5.5f ",LT/D>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
#printf "LT_D_1 = %5.5f ",LT.sens_sol_state_1/D.sens_sol_state_1>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;

printf "\n">>pertubasjon1.m;

printf "VB_B = %5.5f ",VB/B>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
#printf "VB_B_1 = %5.5f ",VB.sens_sol_state_1/B.sens_sol_state_1>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;

printf "\n">>pertubasjon1.m;

printf "B = %5.5f ",B>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
printf "B_1 = %5.5f ",B.sens_sol_state_1>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;

printf "\n">>pertubasjon1.m;

printf "D = %5.5f ", D>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
printf "D_1 = %5.5f ",D.sens_sol_state_1>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;

printf "\n">>pertubasjon1.m;

printf "xB = %5.5f ", 1-x[1]>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
printf "xB_1 = %5.5f ",1-x.sens_sol_state_1[1]>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;

printf "\n">>pertubasjon1.m;

printf "xD = %5.5f ", x[NT]>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
printf "xD_1 = %5.5f ",x.sens_sol_state_1[NT]>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;

printf "\n">>pertubasjon1.m;

printf "cost = %5.5f ", cost>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
printf "cost_1 = %5.5f ",cost.sens_sol_state_1>>pertubasjon1.m; printf ";\n">>pertubasjon1.m;

# plot the results

# printf "subplot(2,1,1)\n" >>pertubasjon1.m;
# printf "plot(stage,x)\n" >>pertubasjon1.m;
# printf "xlabel ('stage number')">>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
# printf "ylabel ('composition')">>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
# printf "subplot(2,1,2)\n" >>pertubasjon1.m;
# printf "plot(stage,T)\n" >>pertubasjon1.m;
# printf "axis([1 41])">>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
# printf "subplot(3,1,3)\n" >>pertubasjon1.m;
# printf "plot(time,u)\n" >>pertubasjon1.m;
# printf "xlabel ('time')">>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
# printf "ylabel ('cooling w flowrate')">>pertubasjon1.m; printf ";\n">>pertubasjon1.m;
  

close pertubasjon1.m;
printf "output written to matlab m-file: pertubasjon1.m ...\n";
#-- end of the pertubasjon1shicks.inc file -

