# ===================================================================
# dynamic optimization formulation of the hicks-ray reactor
# create results file for matlab
# victor m zavala  march 2006
# ===================================================================

printf "clc\n" >case1a_xD.m;
printf "clear all" >case1a_xD.m;
printf "\n" >case1a_xD.m;

# display variables and parameters

printf "\n">>case1a_xD.m;

printf "x =[" >case1a_xD.m;
printf {i in 1..NT}:
"%5.5f ",x[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "x_1 =[" >case1a_xD.m;
printf {i in 1..NT}:
"%5.5f ",x.sens_sol_state_1[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "x_2 =[" >case1a_xD.m;
printf {i in 1..NT}:
"%5.5f ",x.sens_sol_state_2[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "x_3 =[" >case1a_xD.m;
printf {i in 1..NT}:
"%5.5f ",x.sens_sol_state_3[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "x_4 =[" >case1a_xD.m;
printf {i in 1..NT}:
"%5.5f ",x.sens_sol_state_4[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "M =[" >case1a_xD.m;
printf {i in NT+1..NT*2}:
"%5.5f ",x[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "M_1 =[" >case1a_xD.m;
printf {i in NT+1..NT*2}:
"%5.5f ",x.sens_sol_state_1[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "M_2 =[" >case1a_xD.m;
printf {i in NT+1..NT*2}:
"%5.5f ",x.sens_sol_state_2[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "M_3 =[" >case1a_xD.m;
printf {i in NT+1..2*NT}:
"%5.5f ",x.sens_sol_state_3[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "M_4 =[" >case1a_xD.m;
printf {i in NT+1..NT*2}:
"%5.5f ",x.sens_sol_state_4[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "T0 =[" >case1a_xD.m;
printf {i in 1..NT}:
"%5.5f ",T0[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "T1 =[" >case1a_xD.m;
printf {i in 1..NT}:
"%5.5f ",T1[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "T2 =[" >case1a_xD.m;
printf {i in 1..NT}:
"%5.5f ",T2[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "T3 =[" >case1a_xD.m;
printf {i in 1..NT}:
"%5.5f ",T3[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "T4 =[" >case1a_xD.m;
printf {i in 1..NT}:
"%5.5f ",T4[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "dT1 =[" >case1a_xD.m;
printf {i in 1..NT}:
"%5.5f ",dT1[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "dT2 =[" >case1a_xD.m;
printf {i in 1..NT}:
"%5.5f ",dT2[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "dT3 =[" >case1a_xD.m;
printf {i in 1..NT}:
"%5.5f ",dT3[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "stage =[" >case1a_xD.m;
printf {i in 1..NT}:
"%5.5f ",stage[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "\n">>case1a_xD.m;



printf "L =[" >case1a_xD.m;
printf {i in 2..NT}:
"%5.5f ",L[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;
printf "L_1 =[" >case1a_xD.m;
printf {i in 2..NT}:
"%5.5f ",L.sens_sol_state_1[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;
printf "L_2 =[" >case1a_xD.m;
printf {i in 2..NT}:
"%5.5f ",L.sens_sol_state_2[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;
printf "L_3 =[" >case1a_xD.m;
printf {i in 2..NT}:
"%5.5f ",L.sens_sol_state_3[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;
printf "L_4 =[" >case1a_xD.m;
printf {i in 2..NT}:
"%5.5f ",L.sens_sol_state_4[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "V =[" >case1a_xD.m;
printf {i in 1..NT-1}:
"%5.5f ",V[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;
printf "V_1 =[" >case1a_xD.m;
printf {i in 1..NT-1}:
"%5.5f ",V.sens_sol_state_1[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;
printf "V_2 =[" >case1a_xD.m;
printf {i in 1..NT-1}:
"%5.5f ",V.sens_sol_state_2[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;
printf "V_3 =[" >case1a_xD.m;
printf {i in 1..NT-1}:
"%5.5f ",V.sens_sol_state_3[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;
printf "V_4 =[" >case1a_xD.m;
printf {i in 1..NT-1}:
"%5.5f ",V.sens_sol_state_4[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "y =[" >case1a_xD.m;
printf {i in 1..NT-1}:
"%5.5f ",y[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;
printf "y_1 =[" >case1a_xD.m;
printf {i in 1..NT-1}:
"%5.5f ",y.sens_sol_state_1[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;
printf "y_2 =[" >case1a_xD.m;
printf {i in 1..NT-1}:
"%5.5f ",y.sens_sol_state_2[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;
printf "y_3 =[" >case1a_xD.m;
printf {i in 1..NT-1}:
"%5.5f ",y.sens_sol_state_3[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;
printf "y_4 =[" >case1a_xD.m;
printf {i in 1..NT-1}:
"%5.5f ",y.sens_sol_state_4[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "nominal_F = %5.2f ",F>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d1_perturbed_F = %5.2f ",F.sens_sol_state_1>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d2_perturbed_F = %5.2f ",F.sens_sol_state_2>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d3_perturbed_F = %5.2f ",F.sens_sol_state_3>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d4_perturbed_F = %5.2f ",F.sens_sol_state_4>>case1a_xD.m; printf ";\n">>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "nominal_pV = %5.5f ",pV>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d1_perturbed_pV = %5.5f ",pV.sens_sol_state_1>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d2_perturbed_pV = %5.5f ",pV.sens_sol_state_2>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d3_perturbed_pV = %5.5f ",pV.sens_sol_state_3>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d4_perturbed_pV = %5.5f ",pV.sens_sol_state_4>>case1a_xD.m; printf ";\n">>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "nominal_zF = %5.2f ",zF>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d1_perturbed_zF = %5.2f ",zF.sens_sol_state_1>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d2_perturbed_zF = %5.2f ",zF.sens_sol_state_2>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d3_perturbed_zF = %5.2f ",zF.sens_sol_state_3>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d4_perturbed_zF = %5.2f ",zF.sens_sol_state_4>>case1a_xD.m; printf ";\n">>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "nominal_qF = %5.2f ",qF>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d1_perturbed_qF = %5.2f ",qF.sens_sol_state_1>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d2_perturbed_qF = %5.2f ",qF.sens_sol_state_2>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d3_perturbed_qF = %5.2f ",qF.sens_sol_state_3>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "d4_perturbed_qF = %5.2f ",qF.sens_sol_state_4>>case1a_xD.m; printf ";\n">>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "LT = %5.5f ",LT>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "LT_1 = %5.5f ",LT.sens_sol_state_1>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "LT_2 = %5.5f ",LT.sens_sol_state_2>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "LT_3 = %5.5f ",LT.sens_sol_state_3>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "LT_4 = %5.5f ",LT.sens_sol_state_4>>case1a_xD.m; printf ";\n">>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "VB = %5.5f ",VB>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "VB_1 = %5.5f ",VB.sens_sol_state_1>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "VB_2 = %5.5f ",VB.sens_sol_state_2>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "VB_3 = %5.5f ",VB.sens_sol_state_3>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "VB_4 = %5.5f ",VB.sens_sol_state_4>>case1a_xD.m; printf ";\n">>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "LT_F = %5.5f ",LT/F>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "LT_F_1 = %5.5f ",LT.sens_sol_state_1/F.sens_sol_state_1>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "LT_F_2 = %5.5f ",LT.sens_sol_state_2/F.sens_sol_state_2>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "LT_F_3 = %5.5f ",LT.sens_sol_state_3/F.sens_sol_state_3>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "LT_F_4 = %5.5f ",LT.sens_sol_state_4/F.sens_sol_state_4>>case1a_xD.m; printf ";\n">>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "VB_F = %5.5f ",VB/F>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "VB_F_1 = %5.5f ",VB.sens_sol_state_1/F.sens_sol_state_1>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "VB_F_2 = %5.5f ",VB.sens_sol_state_2/F.sens_sol_state_2>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "VB_F_3 = %5.5f ",VB.sens_sol_state_3/F.sens_sol_state_3>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "VB_F_4 = %5.5f ",VB.sens_sol_state_4/F.sens_sol_state_4>>case1a_xD.m; printf ";\n">>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "LT_D = %5.5f ",LT/D>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "LT_D_1 = %5.5f ",LT.sens_sol_state_1/D.sens_sol_state_1>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "LT_D_2 = %5.5f ",LT.sens_sol_state_2/D.sens_sol_state_2>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "LT_D_3 = %5.5f ",LT.sens_sol_state_3/D.sens_sol_state_3>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "LT_D_4 = %5.5f ",LT.sens_sol_state_4/D.sens_sol_state_4>>case1a_xD.m; printf ";\n">>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "VB_B = %5.5f ",VB/B>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "VB_B_1 = %5.5f ",VB.sens_sol_state_1/B.sens_sol_state_1>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "VB_B_2 = %5.5f ",VB.sens_sol_state_2/B.sens_sol_state_2>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "VB_B_3 = %5.5f ",VB.sens_sol_state_3/B.sens_sol_state_3>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "VB_B_4 = %5.5f ",VB.sens_sol_state_4/B.sens_sol_state_4>>case1a_xD.m; printf ";\n">>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "B = %5.5f ",B>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "B_1 = %5.5f ",B.sens_sol_state_1>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "B_2 = %5.5f ",B.sens_sol_state_2>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "B_3 = %5.5f ",B.sens_sol_state_3>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "B_4 = %5.5f ",B.sens_sol_state_4>>case1a_xD.m; printf ";\n">>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "D = %5.5f ", D>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "D_1 = %5.5f ",D.sens_sol_state_1>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "D_2 = %5.5f ",D.sens_sol_state_2>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "D_3 = %5.5f ",D.sens_sol_state_3>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "D_4 = %5.5f ",D.sens_sol_state_4>>case1a_xD.m; printf ";\n">>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "xB = %5.5f ", 1-x[1]>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "xB_1 = %5.5f ",1-x.sens_sol_state_1[1]>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "xB_2 = %5.5f ",1-x.sens_sol_state_2[1]>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "xB_3 = %5.5f ",1-x.sens_sol_state_3[1]>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "xB_4 = %5.5f ",1-x.sens_sol_state_4[1]>>case1a_xD.m; printf ";\n">>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "xD = %5.5f ", x[NT]>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "xD_1 = %5.5f ",x.sens_sol_state_1[NT]>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "xD_2 = %5.5f ",x.sens_sol_state_2[NT]>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "xD_3 = %5.5f ",x.sens_sol_state_3[NT]>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "xD_4 = %5.5f ",x.sens_sol_state_4[NT]>>case1a_xD.m; printf ";\n">>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "cost = %5.5f ", cost>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "cost_1 = %5.5f ",cost.sens_sol_state_1>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "cost_2 = %5.5f ",cost.sens_sol_state_2>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "cost_3 = %5.5f ",cost.sens_sol_state_3>>case1a_xD.m; printf ";\n">>case1a_xD.m;
printf "cost_4 = %5.5f ",cost.sens_sol_state_4>>case1a_xD.m; printf ";\n">>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "FFF =[" >case1a_xD.m;
printf {j in 1..NT+6}:
"%5.10f ",FFF[1,j]>>case1a_xD.m;
printf ";\n">>case1a_xD.m;
printf {j in 1..NT+6}:
"%5.10f ",FFF[2,j]>>case1a_xD.m;
printf ";\n">>case1a_xD.m;
printf {j in 1..NT+6}:
"%5.10f ",FFF[3,j]>>case1a_xD.m;
printf ";\n">>case1a_xD.m;
printf {j in 1..NT+6}:
"%5.10f ",FFF[4,j]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "\n">>case1a_xD.m;

printf "span =[" >case1a_xD.m;
printf {i in 1..NT+6}:
"%5.5f ",span[i]>>case1a_xD.m;
printf "]';\n" >>case1a_xD.m;

printf "\n">>case1a_xD.m;

# plot the results

# printf "subplot(2,1,1)\n" >>case1a_xD.m;
# printf "plot(stage,x)\n" >>case1a_xD.m;
# printf "xlabel ('stage number')">>case1a_xD.m; printf ";\n">>case1a_xD.m;
# printf "ylabel ('composition')">>case1a_xD.m; printf ";\n">>case1a_xD.m;
# printf "subplot(2,1,2)\n" >>case1a_xD.m;
# printf "plot(stage,T1)\n" >>case1a_xD.m;



close case1a_xD.m;
printf "output written to matlab m-file: case1a_xD.m ...\n";
#-- end of the graphshicks.inc file -

