# ===================================================================
# dynamic optimization formulation of the hicks-ray reactor
# create results file for matlab
# victor m zavala  march 2006
# ===================================================================

printf "clc\n" >case2_xB.m;
printf "clear all" >case2_xB.m;
printf "\n" >case2_xB.m;

# display variables and parameters

printf "\n">>case2_xB.m;

printf "x0_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x1[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x1[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "x1_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x1.sens_sol_state_1[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x1.sens_sol_state_1[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "x2_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x1.sens_sol_state_2[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x1.sens_sol_state_2[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;


printf "x3_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x1.sens_sol_state_3[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x1.sens_sol_state_3[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
 

printf "x0_2 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x2[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x2[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "x1_2 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x2.sens_sol_state_1[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x2.sens_sol_state_1[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "x2_2 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x2.sens_sol_state_2[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x2.sens_sol_state_2[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;


printf "x3_2 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x2.sens_sol_state_3[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",x2.sens_sol_state_3[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "M_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",M1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "M_1_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",M1.sens_sol_state_1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "M_2_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",M1.sens_sol_state_2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "M_3_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",M1.sens_sol_state_3[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;


printf "M_2 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",M2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "M_1_2 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",M2.sens_sol_state_1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "M_2_2 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",M2.sens_sol_state_2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "M_3_2 =[" >case2_xB.m;
printf {i in 1..2}:
"%5.5f ",M2.sens_sol_state_3[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;



printf "T0_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",T0_1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "T1_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",T1_1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "T2_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",T2_1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "T3_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",T3_1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "T0_2 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",T0_2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "T1_2=[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",T1_2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "T2_2 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",T2_2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "T3_2 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",T3_2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;


printf "dT1_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",dT1_1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "dT2_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",dT2_1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "dT3_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",dT3_1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "dT1_2 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",dT1_2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "dT2_2 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",dT2_2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "dT3_2 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",dT3_2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "stage_1 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",stage_1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
printf "stage_2 =[" >case2_xB.m;
printf {i in 1..NT}:
"%5.5f ",stage_2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "\n">>case2_xB.m;



printf "L0_1 =[" >case2_xB.m;
printf {i in 2..NT}:
"%5.5f ",L1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
printf "L1_1 =[" >case2_xB.m;
printf {i in 2..NT}:
"%5.5f ",L1.sens_sol_state_1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
printf "L2_1 =[" >case2_xB.m;
printf {i in 2..NT}:
"%5.5f ",L1.sens_sol_state_2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
printf "L3_1 =[" >case2_xB.m;
printf {i in 2..NT}:
"%5.5f ",L1.sens_sol_state_3[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "L2 =[" >case2_xB.m;
printf {i in 2..NT}:
"%5.5f ",L2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
printf "L1_2 =[" >case2_xB.m;
printf {i in 2..NT}:
"%5.5f ",L2.sens_sol_state_1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
printf "L2_2 =[" >case2_xB.m;
printf {i in 2..NT}:
"%5.5f ",L2.sens_sol_state_2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
printf "L3_2 =[" >case2_xB.m;
printf {i in 2..NT}:
"%5.5f ",L2.sens_sol_state_3[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "\n">>case2_xB.m;

printf "V0_1 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",V1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
printf "V1_1 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",V1.sens_sol_state_1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
printf "V2_1 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",V1.sens_sol_state_2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
printf "V3_1 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",V1.sens_sol_state_3[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "V0_2 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",V2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
printf "V1_2 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",V2.sens_sol_state_1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
printf "V2_2 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",V2.sens_sol_state_2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
printf "V3_2 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",V2.sens_sol_state_3[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "\n">>case2_xB.m;

printf "y0_1 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y1[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y1[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;


printf "y1_1 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y1.sens_sol_state_1[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y1.sens_sol_state_1[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;


printf "y2_1 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y1.sens_sol_state_2[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y1.sens_sol_state_2[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;


printf "y3_1 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y1.sens_sol_state_3[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y1.sens_sol_state_3[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;


printf "y0_2 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y2[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y2[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;


printf "y1_2 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y2.sens_sol_state_1[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y2.sens_sol_state_1[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;


printf "y2_2 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y2.sens_sol_state_2[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y2.sens_sol_state_2[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;


printf "y3_2 =[" >case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y2.sens_sol_state_3[i,1]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {i in 1..NT-1}:
"%5.5f ",y2.sens_sol_state_3[i,2]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;


printf "\n">>case2_xB.m;

printf "nominal_F = %5.2f ",F>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "d1_perturbed_F = %5.2f ",F.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "d2_perturbed_F = %5.2f ",F.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "d3_perturbed_F = %5.2f ",F.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "nominal_pV = %5.5f ",pV>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "d1_perturbed_pV = %5.5f ",pV.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "d2_perturbed_pV = %5.5f ",pV.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "d3_perturbed_pV = %5.5f ",pV.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "nominal_qF = %5.2f ",qF>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "d1_perturbed_qF = %5.2f ",qF.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "d2_perturbed_qF = %5.2f ",qF.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "d3_perturbed_qF = %5.2f ",qF.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "LT0_1 = %5.5f ",LT1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT1_1 = %5.5f ",LT1.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT2_1 = %5.5f ",LT1.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT3_1 = %5.5f ",LT1.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "LT0_2 = %5.5f ",LT2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT1_2 = %5.5f ",LT2.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT2_2 = %5.5f ",LT2.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT3_2 = %5.5f ",LT2.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "VB0_1 = %5.5f ",VB1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB1_1 = %5.5f ",VB1.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB2_1 = %5.5f ",VB1.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB3_1 = %5.5f ",VB1.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "VB0_2 = %5.5f ",VB2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB1_2 = %5.5f ",VB2.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB2_2 = %5.5f ",VB2.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB3_2 = %5.5f ",VB2.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "B0_1 = %5.5f ",B1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "B1_1 = %5.5f ",B1.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "B2_1 = %5.5f ",B1.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "B3_1 = %5.5f ",B1.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "D0_1 = %5.5f ", D1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "D1_1 = %5.5f ",D1.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "D2_1 = %5.5f ",D1.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "D3_1 = %5.5f ",D1.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "LT1_F = %5.5f ",LT1/F>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT1_F_1 = %5.5f ",LT1.sens_sol_state_1/F.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT1_F_2 = %5.5f ",LT1.sens_sol_state_2/F.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT1_F_3 = %5.5f ",LT1.sens_sol_state_3/F.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "VB1_F = %5.5f ",VB1/F>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB1_F_1 = %5.5f ",VB1.sens_sol_state_1/F.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB1_F_2 = %5.5f ",VB1.sens_sol_state_2/F.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB1_F_3 = %5.5f ",VB1.sens_sol_state_3/F.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "LT1_D = %5.5f ",LT1/D1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT1_D_1 = %5.5f ",LT1.sens_sol_state_1/D1.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT1_D_2 = %5.5f ",LT1.sens_sol_state_2/D1.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT1_D_3 = %5.5f ",LT1.sens_sol_state_3/D1.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "VB1_B1 = %5.5f ",VB1/B1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB1_B1_1 = %5.5f ",VB1.sens_sol_state_1/B1.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB1_B1_2 = %5.5f ",VB1.sens_sol_state_2/B1.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB1_B1_3 = %5.5f ",VB1.sens_sol_state_3/B1.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "LT2_B1 = %5.5f ",LT2/B1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT2_B1_1 = %5.5f ",LT2.sens_sol_state_1/B1.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT2_B1_2 = %5.5f ",LT2.sens_sol_state_2/B1.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT2_B1_3 = %5.5f ",LT2.sens_sol_state_3/B1.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "VB2_B1 = %5.5f ",VB2/B1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB2_B1_1 = %5.5f ",VB2.sens_sol_state_1/B1.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB2_B1_2 = %5.5f ",VB2.sens_sol_state_2/B1.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB2_B1_3 = %5.5f ",VB2.sens_sol_state_3/B1.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "LT2_D2 = %5.5f ",LT2/D2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT2_D2_1 = %5.5f ",LT2.sens_sol_state_1/D2.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT2_D2_2 = %5.5f ",LT2.sens_sol_state_2/D2.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "LT2_D2_3 = %5.5f ",LT2.sens_sol_state_3/D2.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "VB2_B2 = %5.5f ",VB2/B2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB2_B2_1 = %5.5f ",VB2.sens_sol_state_1/B2.sens_sol_state_1>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB2_B2_2 = %5.5f ",VB2.sens_sol_state_2/B2.sens_sol_state_2>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "VB2_B2_3 = %5.5f ",VB2.sens_sol_state_3/B2.sens_sol_state_3>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "xA = %5.5f ", x1[NT,1]>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "xA_1 = %5.5f ",x1.sens_sol_state_1[NT,1]>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "xA_2 = %5.5f ",x1.sens_sol_state_2[NT,1]>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "xA_3 = %5.5f ",x1.sens_sol_state_3[NT,1]>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "xB_1 = %5.5f ", x2[NT,2]>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "xB_1 = %5.5f ",x2.sens_sol_state_1[NT,2]>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "xB_1 = %5.5f ",x2.sens_sol_state_2[NT,2]>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "xB_1 = %5.5f ",x2.sens_sol_state_3[NT,2]>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "xC_1 = %5.5f ",1-x2[1,1]-x2[1,2]>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "xC_1 = %5.5f ",1-x2.sens_sol_state_1[1,1]-x2.sens_sol_state_1[1,2]>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "xC_1 = %5.5f ",1-x2.sens_sol_state_2[1,1]-x2.sens_sol_state_2[1,2]>>case2_xB.m; printf ";\n">>case2_xB.m;
printf "xC_1 = %5.5f ",1-x2.sens_sol_state_3[1,1]-x2.sens_sol_state_3[1,2]>>case2_xB.m; printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "cost = %5.5f ", cost>>case2_xB.m; printf ";\n">>case2_xB.m;


printf "\n">>case2_xB.m;

printf "FFF_1 =[" >case2_xB.m;
printf {j in 1..NT+6}:
"%5.10f ",FFF_1[1,j]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {j in 1..NT+6}:
"%5.10f ",FFF_1[2,j]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {j in 1..NT+6}:
"%5.10f ",FFF_1[3,j]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;

printf "FFF_2 =[" >case2_xB.m;
printf {j in 1..NT+6}:
"%5.10f ",FFF_2[1,j]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {j in 1..NT+6}:
"%5.10f ",FFF_2[2,j]>>case2_xB.m;
printf ";\n">>case2_xB.m;
printf {j in 1..NT+6}:
"%5.10f ",FFF_2[3,j]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;
printf ";\n">>case2_xB.m;

printf "\n">>case2_xB.m;


printf "span_1 =[" >case2_xB.m;
printf {i in 1..NT+6}:
"%5.5f ",span_1[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "\n">>case2_xB.m;

printf "span_2 =[" >case2_xB.m;
printf {i in 1..NT+6}:
"%5.5f ",span_2[i]>>case2_xB.m;
printf "]';\n" >>case2_xB.m;

printf "\n">>case2_xB.m;


 
# # plot the results
# 
# # printf "subplot(2,1,1)\n" >>case2_xB.m;
# # printf "plot(stage,x)\n" >>case2_xB.m;
# # printf "xlabel ('stage number')">>case2_xB.m; printf ";\n">>case2_xB.m;
# # printf "ylabel ('composition')">>case2_xB.m; printf ";\n">>case2_xB.m;
# # printf "subplot(2,1,2)\n" >>case2_xB.m;
# # printf "plot(stage,T1)\n" >>case2_xB.m;
 
 
 
close case2_xB.m;
printf "output written to matlab m-file: case2_xB.m ...\n";
# #-- end of the graphshicks.inc file -
 
