!#define A_IN      (prhs(1))
!#define RHS_IN    (prhs(2))
!#define REV_IN    (prhs(3))
!#define NITRE     (prhs(4))

!#define RHS_OUT   (plhs(1))
!#define INFO_OUT  (plhs(2))
!#define RINFO_OUT (plhs(3))


! The gateway subroutine
SUBROUTINE mexFunction( nlhs, plhs, nrhs, prhs )

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                              STATEMENT                              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      use hsl_matlab

      IMPLICIT NONE

! External mex-functions

      INTEGER * 4 :: nlhs, nrhs
      integer(mwp_) :: plhs( * ), prhs( * )

      DOUBLE PRECISION :: mxGetNaN

      integer(mwp_) :: fptr,mxGetField
      integer(mwi_) :: ind_i

! pointer for input/output parameters and local variables

      INTEGER, DIMENSION(:), ALLOCATABLE :: ip_in,irn_in,jcn,irn
      INTEGER, DIMENSION(:), ALLOCATABLE :: ifact,icntl,iwork,info

      DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: fact,xxx,work,temp,val
      DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: val_in,resid,rhs
      DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: cntl,rinfo

      INTEGER(mws_) :: lcntl, licntl, linfo, lrinfo
      INTEGER(mws_) :: mwlfact,mwlifact,mwlwork
      integer :: lfact, lifact, lwork
      INTEGER :: i,j,ne,ne_in,itre,job,jobcd,err,nitre
      INTEGER(mws_) :: mwn,mwm,mwlrhs
      integer :: n, m, lrhs, n_rhs

      DOUBLE PRECISION :: zero,NaN
      DOUBLE PRECISION :: start,finish,count_time_s,count_time_ir

      CHARACTER*132 msg
      CHARACTER (50) value,value2
      LOGICAL :: bool

      CHARACTER(LEN=6) f1, f2,f3,f4,f5,f6,f7,f8
      CHARACTER(LEN=6), DIMENSION(8):: fieldnames

      INTRINSIC :: max, cpu_time,IDINT

!parameter
      f1 = 'lfact '
      f2 = 'fact  '
      f3 = 'lifact'
      f4 = 'ifact '
      f5 = 'cntl  '
      f6 = 'icntl '
      f7 = 'info  '
      f8 = 'rinfo '
      fieldnames = (/f1,f2,f3,f4,f5,f6,f7,f8/)
      ind_i = 1

      zero = 0.0D+0
      count_time_s = 0
      count_time_ir = 0
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                               CODE                                  !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


! Check of input arguments

      IF ( (nrhs < 3) .or. (nrhs > 4) ) THEN
        CALL mexErrMsgTxt( " Wrong # of input arguments " )
      END IF
      IF ( (nlhs > 3) ) THEN
        CALL mexErrMsgTxt( " Wrong # of output arguments " )
      END IF
!
!check if A sparse and square
!
      mwm = MATLAB_get_m(prhs(1))
      mwn = MATLAB_get_n(prhs(1))
      m = mwm
      n = mwn
      IF ((n .ne. m) .or. (.not.MATLAB_is_sparse(prhs(1)))) THEN
        CALL mexErrMsgTxt("The input matrix A must be square and sparse")
      END IF
!
! Read the rhs dimensions
!
      mwlrhs  = MATLAB_get_m(prhs(2));
      n_rhs = MATLAB_get_n(prhs(2));

      IF (mwlrhs .ne. n) THEN
        CALL mexErrMsgTxt( &
          "The RHS has dimensions incompatible with the input matrix")
      END IF
! TEST STRUCTURE
      IF (.not. MATLAB_is_structure(prhs(3))) THEN
        call mexErrMsgTxt('The third entry is not a structure')
      END IF
!
! CHECK IF INFO(1) == 0 AND, THUS, IF THE SOLUTION PHASE IS FEASIBLE
!
! Read from Structure the values of info and rinfo
!
      fptr = mxGetField(prhs(3), ind_i, f7)
      call matlab_to_fortran(fptr, info, linfo, 'info')
      fptr = mxGetField(prhs(3), ind_i, f8)
      call matlab_to_fortran(fptr, rinfo, lrinfo, 'rinfo')

      IF (info(1) >= 0) THEN

! get the output arguments of ma57_fact

        IF (info(1) == 4) THEN
          CALL mexWarnMsgTxt("The matrix is not full rank: look at info(25)")
        END IF

!read the other fields of structure


        fptr = mxGetField(prhs(3), ind_i, f1)
        call matlab_to_fortran(fptr, mwlfact, 'lfact')
        fptr = mxGetField(prhs(3), ind_i, f2)
        call matlab_to_fortran(fptr, fact, mwlfact, 'fact')
        fptr = mxGetField(prhs(3), ind_i, f3)
        call matlab_to_fortran(fptr, mwlifact, 'lifact')
        fptr = mxGetField(prhs(3), ind_i, f4)
        call matlab_to_fortran(fptr, ifact, mwlifact, 'ifact')
        fptr = mxGetField(prhs(3), ind_i, f5)
        call matlab_to_fortran(fptr, cntl, lcntl, 'cntl')
        fptr = mxGetField(prhs(3), ind_i, f6)
        call matlab_to_fortran(fptr, icntl, licntl, 'icntl')
        fptr = mxGetField(prhs(3), ind_i, f7)
        call matlab_to_fortran(fptr, info, linfo, 'info')
        fptr = mxGetField(prhs(3), ind_i, f8)
        call matlab_to_fortran(fptr, rinfo, lrinfo, 'rinfo')

        lfact = mwlfact
        lifact = mwlifact


        IF (nrhs == 4) THEN
          call matlab_to_fortran(prhs(4),nitre,'NITRE')
          IF (icntl(9) .ne. nitre) THEN
            icntl(9) = nitre
          END IF
        END IF
        IF (icntl(9) .le. 0) THEN
            CALL mexWarnMsgTxt("Iterative refinement is not executed")
        END IF

        itre = 0

        IF (info(1) == 0) THEN
          IF (icntl(9) > 0) THEN
            itre = 1
          END IF
          IF (n_rhs > 1) THEN
            itre = 0
          END IF
        END IF
        IF (icntl(9) .le. 0) THEN
          itre = 0
        END IF

! here begins part where iter == 0

        IF (itre == 0) THEN
          jobcd = 1
          lwork = mwlrhs*n_rhs

          ALLOCATE( iwork( lwork ) , STAT = err)
          IF (err .ne. 0) THEN
            CALL mexErrMsgTxt( " Out of memory 1" )
          END IF
          ALLOCATE( work( lwork ) , STAT = err)
          IF (err .ne. 0) THEN
            CALL mexErrMsgTxt( " Out of memory 2" )
          END IF
          IF (n_rhs > 1) THEN
            call matlab_to_fortran(prhs(2),xxx,mwlwork,"x")
          ELSE
            call matlab_to_fortran(prhs(2),xxx,mwlrhs,"x")
          END IF


          lrhs = mwlrhs
          CALL cpu_time(start)
          CALL ma57cd(jobcd,n,fact,lfact,ifact,lifact,n_rhs,xxx,lrhs,work, &
            lwork,iwork,icntl,info)
          CALL cpu_time(finish)
          count_time_s = count_time_s + (finish - start)
          rinfo(23) = count_time_s


! Fix output arguments

          IF (nlhs > 1) THEN
            plhs(2) = fortran_to_matlab(info)
          END IF

          IF (nlhs > 2) THEN
            plhs(3) = fortran_to_matlab(rinfo)
          END IF

          plhs(1) = fortran_to_matlab(xxx)

! Free workspace

          IF ( ALLOCATED( icntl ) ) DEALLOCATE( icntl, STAT = err)
          IF ( ALLOCATED( cntl ) ) DEALLOCATE( cntl, STAT = err)
          IF ( ALLOCATED( iwork ) ) DEALLOCATE( iwork, STAT = err)
          IF ( ALLOCATED( work ) ) DEALLOCATE( work, STAT = err)
          IF ( ALLOCATED( xxx ) ) DEALLOCATE( xxx, STAT = err)
          IF ( ALLOCATED( fact ) ) DEALLOCATE( fact, STAT = err)
          IF ( ALLOCATED( ifact ) ) DEALLOCATE( ifact, STAT = err)

        END IF
! here ends part where iter == 0

! here begins part where iter == 1

        IF (itre == 1) THEN

          job = 2
          jobcd = 1


! read A
          call matlab_to_fortran(prhs(1),mwm,mwn,ip_in,irn_in,val_in,"A")

! ne = number of nonzero
          ne = ip_in(n+1)

!
! Allocate the space for the lower triangular part of the input matrix
!
          ALLOCATE( jcn( ne ), STAT = err )
          IF (err .ne. 0) THEN
          CALL mexErrMsgTxt( " Out of memory 3" )
          END IF
          ALLOCATE( irn( ne ), STAT = err )
          IF (err .ne. 0) THEN
          CALL mexErrMsgTxt( " Out of memory 4" )
          END IF
          ALLOCATE( val( ne ), STAT = err )
          IF (err .ne. 0) THEN
          CALL mexErrMsgTxt( " Out of memory 5" )
          END IF

          ne_in = 0
          DO i=1,n
          DO j=ip_in(i),ip_in(i+1)-1
               IF ((irn_in(j)) .ge. i) THEN
               ne_in = ne_in +1
               jcn(ne_in) = i
               irn(ne_in) = irn_in(j)
               val(ne_in) = val_in(j)
               END IF
          END DO
          END DO
          ne = ne_in


          IF ( ALLOCATED( ip_in  ) ) DEALLOCATE( ip_in,  STAT = err)
          IF ( ALLOCATED( irn_in ) ) DEALLOCATE( irn_in, STAT = err)
          IF ( ALLOCATED( val_in ) ) DEALLOCATE( val_in, STAT = err)

! allocate workspace

          call matlab_to_fortran(prhs(2),xxx,mwlrhs,"x (out of memory)")
          call matlab_to_fortran(prhs(2),rhs,mwlrhs,"x (out of memory)")

          ALLOCATE( resid( mwlrhs ) , STAT = err)
          IF (err .ne. 0) THEN
            CALL mexErrMsgTxt( " Out of memory 6" )
          END IF

          ALLOCATE( iwork( mwlrhs ) , STAT = err)
          IF (err .ne. 0) THEN
            CALL mexErrMsgTxt( " Out of memory 7" )
          END IF

          DO i=1,mwlrhs
            iwork(i) = 0
          END DO

          lwork = 4*n
          ALLOCATE( work( lwork ) , STAT = err)
          IF (err .ne. 0) THEN
            CALL mexErrMsgTxt( " Out of memory 8" )
          END IF


          DO i=1,lwork
            work(i) = 0
          END DO

! do solve

          !CALL system_clock(count=start, count_rate=c_rate, count_max=c_max)
          lrhs = mwlrhs
          CALL cpu_time(start)
          CALL ma57cd(jobcd,n,fact,lfact,ifact,lifact,n_rhs,xxx,lrhs,work, &
            lwork,iwork,icntl,info)
          CALL cpu_time(finish)
          count_time_s = count_time_s + (finish - start)
          rinfo(23) = count_time_s

!           icntl(9) = 10
          icntl(10) = 1

! do IR

          CALL cpu_time(start)
          CALL ma57dd(job,n,ne,val,irn,jcn,fact,lfact,ifact,lifact,rhs,xxx,&
          &resid,work,iwork,icntl,cntl,info,rinfo)
          CALL cpu_time(finish)
          count_time_ir = count_time_ir + (finish - start)
          rinfo(24) = count_time_ir

! Warning
          IF (info(1) == -8) THEN
            CALL mexWarnMsgTxt( "Iterative refinement did not converge in &
              &specified num. of iters")
          END IF
          IF (info(1) == -14) THEN
            CALL mexWarnMsgTxt( &
              "Failure in the estimates of the conditions numbers")
          END IF



! Fix output arguments

          IF (nlhs > 1) THEN
            plhs(2) = fortran_to_matlab(info)
          END IF

          IF (nlhs > 2) THEN
            plhs(3) = fortran_to_matlab(rinfo)
          END IF

          plhs(1) = fortran_to_matlab(xxx)

! Free workspace

          IF ( ALLOCATED( jcn ) ) DEALLOCATE( jcn, STAT = err)
          IF ( ALLOCATED( irn ) ) DEALLOCATE( irn, STAT = err)
          IF ( ALLOCATED( val ) ) DEALLOCATE( val, STAT = err)
          IF ( ALLOCATED( icntl ) ) DEALLOCATE( icntl, STAT = err)
          IF ( ALLOCATED( cntl ) ) DEALLOCATE( cntl, STAT = err)

          IF ( ALLOCATED( iwork ) ) DEALLOCATE( iwork, STAT = err)
          IF ( ALLOCATED( work ) ) DEALLOCATE( work, STAT = err)
          IF ( ALLOCATED( xxx ) ) DEALLOCATE( xxx, STAT = err)
          IF ( ALLOCATED( rhs ) ) DEALLOCATE( rhs, STAT = err)
          IF ( ALLOCATED( resid ) ) DEALLOCATE( resid, STAT = err)
          IF ( ALLOCATED( fact ) ) DEALLOCATE( fact, STAT = err)
          IF ( ALLOCATED( ifact ) ) DEALLOCATE( ifact, STAT = err)
        END IF
! here ends part where iter == 1

      ELSE
! infoi(1)<0

! Fix output arguments
          NaN = mxGetNaN()
          ALLOCATE ( xxx( n*n_rhs ), STAT = err)
          IF (err .ne. 0) THEN
            CALL mexErrMsgTxt( " Out of memory 9" )
          END IF
          DO i=1,n*n_rhs
            xxx(i) = NaN
          END DO

          plhs(1) = fortran_to_matlab(xxx)
          IF ( ALLOCATED( xxx ) ) DEALLOCATE( xxx, STAT = err)

          IF (nlhs > 1) THEN
            plhs(2) = fortran_to_matlab(info)
          END IF

          IF (nlhs > 2) THEN
            plhs(3) = fortran_to_matlab(rinfo)
          END IF


      END IF

        IF ( ALLOCATED( info ) ) DEALLOCATE( info, STAT = err)
        IF ( ALLOCATED( rinfo ) ) DEALLOCATE( rinfo, STAT = err)

END SUBROUTINE mexFunction

